import BusX
import MPAKX

public protocol MicItemContext {
  var activityDate: MPAK.Recent<Date?> { get }
  var timeout: Bool { get }
}

extension MicItem {
  public struct Model: MicItemContext {
    public var activityDate: MPAK.Recent<Date?> = .init(nil)
    public var timeout: Bool = false
  }
}

extension MicItem {
  final class Controller: MPAK.Controller<MicItem.Model> {
    init() {
      /**/print("MicIC.init")
      super.init(
        MicItem.Model(),
        debugClassName: "MicICtrl",
        debugLog: { print($0) }
      )


      // Нижеследующее предстоит сгенерить.
      m
        .sink { v in Bus.send(K.MI, v) }
        .store(in: &subscriptions)

      pipeValue(
        dbg: "activityD",
        sub: nil,
        Bus.events.compactMap { Bus.convertKeyValue(K.activityDate, $0) }.map { (k: String, v: Date?) in v }.eraseToAnyPublisher(),
        {
          $0.activityDate.value = $1
          $0.activityDate.isRecent = true
        },
        { m, _ in m.activityDate.isRecent = false }
      )

      pipe(
        dbg: "timeout",
        sub: nil,
        Bus.events.compactMap { Bus.convertKeyValue(K.timeout, $0) }.map { (k: String, v: Bool) in v }.eraseToAnyPublisher(),
        { $0.timeout = true },
        { $0.timeout = false }
      )

    }
  }
}
